<template>
  <sui-modal
    v-model="visible"
    size="standart"
    :animation-duration="1"
    v-dom-move
    v-scroll-lock="selectServicesModalShow">
    <i
      class="close icon"
      @click="hideModal"/>
    <div class="header default padding gray">
      <div class="title">Выберите услуги, которые вы предоставляете</div>
    </div>
    <div class="content without padding">
      <div class="block top">
        <div class="ui checkbox">
          <input
            type="checkbox"
            :id="setUniqId(0, type, 'service-all')"
            name="services-all"
            :checked="isSelectedAllBrands()"
            @change="selectAllBrands">
          <label
            :for="setUniqId(0, type, 'service-all')"
            class="medium">Выбрать все услуги ({{ services.length }})</label>
        </div>
      </div>
      <div
        class="block accordion"
        v-if="serviceGroups && serviceGroups.length">
        <div class="scroll">
          <div
            v-for="(serviceGroup, i) in serviceGroups"
            :key="i"
            class="panel"
            :class="{opened : isOpenPanel[i]}">
            <div
              class="title"
              @click="toggleAccordion(i)">
              <span>
                {{ serviceGroup.name }}
              </span>
              <span
                class="count"
                v-if="countSelectedItem(serviceGroup.services)">
                ({{ countSelectedItem(serviceGroup.services) }})
              </span>
            </div>
            <div class="content">
              <div class="ui checkbox">
                <input
                  type="checkbox"
                  :id="setUniqId(i, type, 'service-group')"
                  name="services-all"
                  :checked="isSelectedItemsByType(serviceGroup.services)"
                  @change="selectAllItemsCurrentType($event, serviceGroup.services)">
                <label
                  :for="setUniqId(i, type, 'service-group')"
                  class="medium">
                  Выбрать все {{ serviceGroup.services.length }}
                  {{ serviceGroup.services.length | transChoose(['услугу', 'услуги', 'услуг']) }}
                </label>
              </div>
              <div class="list-checkbox">
                <div
                  v-for="(service, j) in serviceGroup.services"
                  :key="i + j"
                  class="item-checkbox">
                  <div class="ui child checkbox">
                    <input
                      type="checkbox"
                      v-model="service.checked"
                      :id="setUniqId(i, type, 'service' + j)">
                    <label :for="setUniqId(i, type, 'service' + j)">{{ service.contractModal.name }}</label>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="actions without padding ">
      <div class="footer">
        <button
          type="button"
          class="ui button yellow circular inmodal"
          @click="saveChoice">
          Сохранить
        </button>
        <button
          type="button"
          class="ui button transparent inmodal"
          @click="clearAll">
          Очистить все
        </button>
      </div>
    </div>
  </sui-modal>

</template>

<script>
import StoService from '~/assets/js/model/sto-service/sto-service';

export default {
  name: 'ListServices',
  model: {
    prop: 'selectServicesModalShow',
    event: 'change',
  },
  props: {
    selectServicesModalShow: {
      type: Boolean,
      required: true,
    },
    listServices: {
      type: Array,
      default() { return []; },
    },
    currentSelectedListServices: {
      type: Array,
      default() {
        return [];
      },
    },
    type: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      isOpenPanel: {
        type: Array,
        default: false,
      },
      serviceGroups: this.getServiceGroup(this.listServices),
    };
  },
  computed: {
    visible: {
      get() {
        return this.selectServicesModalShow;
      },
      set() {
        this.hideModal();
      },
    },
    services() {
      return this.serviceGroups
        .reduce((acc, item) => acc.concat((item.services && item.services.length)
          ? item.services
          : []), []);
    },
  },
  methods: {
    getServiceGroup(serviceGroups) {
      if (!serviceGroups || !serviceGroups.length) {
        return [];
      }

      return serviceGroups.map(serviceGroup => ({
        ...serviceGroup,
        services: serviceGroup.services.map((service) => {
          const item = new StoService(service);

          item.checked = this.currentSelectedListServices
            .some(currentSelectedListService => currentSelectedListService.id === Number(item.contractModal.id));
          return item;
        }),
      }));
    },
    selectAllBrands(value) {
      if (value && value.target) {
        this.services
          .forEach((item) => { item.checked = value.target.checked; });
      }
    },
    isSelectedAllBrands() {
      if (!this.serviceGroups && !this.serviceGroups.length) {
        return false;
      }

      return this.services
        .every(item => item.checked);
    },
    selectAllItemsCurrentType(value, brands) {
      if (value && value.target) {
        brands.forEach((item) => { item.checked = value.target.checked; });
      }
    },
    isSelectedItemsByType(items) {
      if (!items && !items.length) {
        return false;
      }

      return items.every(brand => brand.checked);
    },
    countSelectedItem(items) {
      if (!items && !items.length) {
        return false;
      }

      return items.filter(brand => brand.checked).length;
    },
    clearAll() {
      this.services
        .forEach((item) => { item.checked = false; });
    },
    saveChoice() {
      this.$emit('set-services', this.getChoice());
      this.hideModal();
    },
    getChoice() {
      const result = {
        serviceGroups: [],
        service: [],
      };

      // TODO: Как можно сделать лучше?
      // Сделать 2 emit для serviceGroups и service??
      this.serviceGroups.forEach((group) => {
        if (group && group.services.some(service => service.checked)) {
          result.serviceGroups.push({
            id: group.id,
          });
          result.service = [...result.service, ...group.services
            .filter(item => item.checked)
            .map((service) => {
              service.contractModal.id = Number(service.contractModal.id);
              return service.contractModal;
            }),
          ];
        }
      });

      return result;
    },
    toggleAccordion(index) {
      this.$set(this.isOpenPanel, index, !this.isOpenPanel[index]);
    },
    hideModal() {
      this.$emit('change', false);
    },
    setUniqId(index, type, str) {
      return `${index}${type}${str}`;
    },
  },
};
</script>

<style scoped lang="scss">
  @import "~assets/scss/modules/_scroll.scss";

  .ui.modal {
    .ui.button.inmodal {
      margin: 0;
    }
    > .content {
      width: 51rem;

      .ui.checkbox label.medium {
        font-weight: 500;
      }
      .ui.checkbox label:not(.medium) {
        font-size: .6875rem;
        height: auto;
      }

      .flexline {
        display: flex;
        flex-flow: row nowrap;
        justify-content: flex-start;
        align-items: stretch;
        border-bottom: 1px solid #dbe4e9;
      }
      .scroll {
        display: block;
        width: 100%;
        height: 100%;
        overflow: auto;
      }

      .block.top {
        display: flex;
        flex-flow: row nowrap;
        justify-content: flex-start;
        align-items: center;
        padding: 0.75rem 2.75rem 0.75rem 2rem;
        .count {
          font-size: 0.8125rem;
          line-height: 1.3;
          font-weight: 400;
          color: #8798a4;
          padding-left: 2rem;
        }
      }

      .block.accordion {
        display: block;
        width: 100%;
        height: 23rem;
        border-bottom: 1px solid #dbe4e9;
        border-top: 1px solid #dbe4e9;
        .panel {
          position: relative;
          margin-bottom: 0.5rem;
          &:last-child {
            margin-bottom: 0;
          }
          .content {
            display: none !important;
          }
          &.opened {
            .content {
              display: flex !important;
            }
            .title:after {
              transform: translate(0, -50%) rotate(0);
            }
          }

          .title {
            display: block;
            position: relative;
            padding: 0.75rem 4rem 0.75rem 2rem;
            font-size: .8125rem;
            line-height: 1.2;
            font-weight: 500;
            background-color: #ededed;
            cursor: pointer;
            .count {
              font-weight: 400;
              padding-left: 0.25rem;
            }
            &:after {
              content: "";
              width: 1rem;
              height: 0.75rem;
              position: absolute;
              display: block;
              background-size: contain;
              background-repeat: no-repeat;
              background-position: center;
              background-image: url("~assets/svg/arrow/up.svg");
              top: 50%;
              right: 2rem;
              transform: translate(0, -50%) rotate(180deg);
            }
          }

          .content {
            width: 100%;
            flex-flow: column nowrap;
            justify-content: flex-start;
            align-items: flex-start;
            padding: 1rem 2rem 1rem 2rem;
            .list-checkbox {
              display: flex;
              flex-flow: row wrap;
              justify-content: flex-start;
              align-items: flex-start;
              width: 100%;
              padding-top: 0.5rem;
              > .item-checkbox {
                display: block;
                width: 33.3333333%;
                padding: 0.5rem 0.5rem 0 0;
              }
            }
          }
        }
      }
    }
  }
</style>
